using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace proTreeView
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            treeView1.Sorted = true;
             string[] drives = Directory.GetLogicalDrives();
            TreeNode node;
            foreach (string drv in drives)
            {
                node = treeView1.Nodes.Add(drv);
                ReadSubDirs(node);
                if (drv == "C:\\")               // C: selektieren
                    treeView1.SelectedNode = node;
            }
        }

        private void ReadSubDirs(TreeNode node)
        {
            DirectoryInfo[] arrDirInfo;  // Array fr Subdirectories
            DirectoryInfo dirinfo = new DirectoryInfo(node.FullPath);
            try
            {
                arrDirInfo = dirinfo.GetDirectories();
            }
            catch
            {
                return;
            }
            foreach (DirectoryInfo DI in arrDirInfo)
            {
                node.Nodes.Add(DI.Name);
            }
        }

        private void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            fileListBox1.Path = e.Node.FullPath;
            fileListBox1.Update();
            e.Node.SelectedImageIndex = 1;
        }

        private void treeView1_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            foreach (TreeNode node in e.Node.Nodes)
            {
                ReadSubDirs(node);
            }
        }

        private void buttonExpand_Click(object sender, EventArgs e)
        {
            treeView1.ExpandAll();
        }


    }
}