﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics; // Für Zeitmessung mit Stopwatch
using MPS; // Aus MultimediaTimer.dll


namespace TimerTest
{
    public partial class FormTimerTest : Form
    {
        public FormTimerTest()
        {
            InitializeComponent();
            toolStripStatusLabel1.Text = " Zählfrequenz= "+Stopwatch.Frequency.ToString()+" Hz";
            stopwatch.Start();
            starttm = stopwatch.ElapsedTicks;

            MMTimer1 = new TMultimediaTimer(null); // --> null means no callback invoking --> less overhead 
                                                   //       --> less CPU load
            MMTimer1.Interval = 10;                 // --> 10ms interval
            MMTimer1.OnTimer = EventVomMMTimer;
            MMTimer1.Enable();


        }

        Stopwatch stopwatch = new Stopwatch();
        double starttm,stoptm,timeAvr=0;
        int cnt = 1;

        TMultimediaTimer MMTimer1;
        double starttmMM, stoptmMM, timeAvrMM = 0,jitter=0,mittelwertMM=0;
        int cntMM = 1;

        private void timer1Sec_Tick(object sender, EventArgs e)
        {
            labelSTimer.Text = (timeAvr / cnt / (float)Stopwatch.Frequency * 1000.0).ToString("F2") + " msec";
            labelMMTimer.Text = (timeAvrMM / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
            timeAvr = 0;
            cnt = 0;
            timeAvrMM = 0;
            cntMM = 0;
        }

        private void timerMessObjekt_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            starttm=stoptm  ;
            stoptm = stopwatch.ElapsedTicks;
            timeAvr += (stoptm - starttm);
            cnt++;
            //toolStripStatusLabel2.Text = stopwatch.ElapsedTicks.ToString();

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            timerMessObjekt.Interval = (int)numericUpDown1.Value;
            MMTimer1.Disable();
            MMTimer1.Interval = (uint)numericUpDown1.Value; // Kann nur verstellt werden, wenn er stoppt
            MMTimer1.Enable();

        }

        private void FormTimerTest_FormClosing(object sender, FormClosingEventArgs e)
        {
            MMTimer1.Disable();
        }

        void EventVomMMTimer(TMultimediaTimer sender)
        {
            starttmMM = stoptmMM;
            stoptmMM = stopwatch.ElapsedTicks;
            timeAvrMM += (stoptmMM - starttmMM);
            cntMM++;
        }

    }
}
