using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication6
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            fileListBox1.Path = dirListBox1.Path;
            dirListBox1.Path = driveListBox1.Drive;
        }

        private void driveListBox1_TextChanged(object sender, EventArgs e)
        {
            dirListBox1.Path = driveListBox1.Drive;
        }

        
        private void dirListBox1_SelectedValueChanged(object sender, EventArgs e)
        {
           
            label1.Text = dirListBox1.Path;
            label2.Text = dirListBox1.Text;
            // in Text appears text of the selected line
            // in path appears the open path. the selected path can now be constructed:
            // if I select a path under open path: selpath=Path+/+Text
            // if I select a path above open path: selpath= find pos of text, delete after text.
            string selpath;
            int pos=dirListBox1.Path.IndexOf(dirListBox1.Text);  // Position of text, if -1 not found
            if (pos < 0)
            {
                selpath = dirListBox1.Path + "\\" + dirListBox1.Text;
            }
            else
            {
                selpath = dirListBox1.Path.Substring(0, pos + dirListBox1.Text.Length);
            }
            label3.Text = selpath;
            fileListBox1.Path = selpath;
        }

        private void buttonCopy_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            for (int i=0;i<fileListBox1.Items.Count;i++)
              textBox1.AppendText(fileListBox1.Items[i].ToString()+ "\x0d" + "\x0a");
      }

        private void fileListBox1_Click(object sender, EventArgs e)
        {
            string fn = fileListBox1.Text;  // selectesd Line
            int len=fn.Length;
            string ext = fn.Substring(len - 4, 4).ToLower();
            if ((ext == ".jpg") || (ext == ".png") || (ext == ".bmp") || (ext == ".gif")|| (ext==".ico"))
            {
                pictureBox1.Load(fileListBox1.Path + "\\" + fn);//  fileListBox1.Items[i].
                label1.Text = pictureBox1.Image.Height.ToString();
                label2.Text = pictureBox1.Image.Width.ToString();
                checkBox1_CheckedChanged( sender,  e);
            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)  // proportional
                if (pictureBox1.Image.Width > pictureBox1.Image.Height)
                {
                    pictureBox1.Width = (int)numericUpDown1.Value;
                    pictureBox1.Height = (int)numericUpDown1.Value * pictureBox1.Image.Height / pictureBox1.Image.Width;
                }
                else
                {
                    pictureBox1.Height = (int)numericUpDown1.Value;
                    pictureBox1.Width = (int)numericUpDown1.Value * pictureBox1.Image.Width / pictureBox1.Image.Height;
                }
            else
            {
                pictureBox1.Height = (int)numericUpDown1.Value;
                pictureBox1.Width = (int)numericUpDown1.Value;
            }
        }
    }
}